#NoEnv
#SingleInstance

Progress b2 fm10 fs8, Locating Eclipse..., Eclipse Cleaner, AHKProgress-CleanEclipse

EclipsePath := "."

Deprecated  := "_deprecated"

Dirs1 := "features"
Dirs2 := "plugins"
Dirs0 := 2

VersionFirstChar := "0123456789"
Ctr := 0
Loop %Dirs0%
{
  CurDir := EclipsePath . "\" . Dirs%A_Index%
  OldFile := ""
  OldPlug := ""
  OldVer  := ""
  
  Bar := 20 + %A_Index% * 30
  Progress %Bar%, Searching duplicate %CurDir%...

  IfNotExist %CurDir%%Deprecated%
  {
    FileCreateDir %CurDir%%Deprecated%
  }

  Loop %CurDir%\*.*, 1, 0
  {
    CurFile := A_LoopFileName
    StringSplit FileParts, CurFile, _
    CurPlug := FileParts1
    CurVer  := FileParts2

    ; wander splitted (by underscore) parts of filename to see if it's a version number
    Loop %FileParts0%
    {
      If (A_Index < 2)
        continue
      CurFP := FileParts%A_Index%
      IfInString VersionFirstChar, % SubStr(CurFP, 1, 1)
      {
        ; contains a number at first pos - must be version
        CurVer := FileParts%A_Index%
        break
      }
      CurPlug .= "_" . FileParts%A_Index%
    }
    
    if (CurPlug = OldPlug)
    {
      Ctr++
      Double%Ctr% := OldFile
      FileGetAttrib FAttr, %CurDir%\%OldFile%
      IfInString FAttr, D
      {
        FileMoveDir %CurDir%\%OldFile%, %CurDir%%Deprecated%\%OldFile%, R
      }
      Else
      {
        FileMove %CurDir%\%OldFile%, %CurDir%%Deprecated%\%OldFile%
      }
    }
    OldFile := CurFile
    OldPlug := CurPlug
    OldVer  := CurVer
  }
}
Double0 := Ctr

Progress 100, All done.

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

msg := ""
Loop %Double0%
{
  CurFile := Double%A_Index%
  StringLower CurFileL, CurFile
  msg .= CurFile
  msg .= ", "
}

Progress OFF
MsgBox `n`n%Double0% features/plugins found:`n`n%msg%